#include "objectinstance.h"
#include "renderer.h"
#include "transform.h"

using namespace std;

namespace Msp {
namespace GL {

ObjectInstance::ObjectInstance(const Object &obj):
	object(obj)
{ }

void ObjectInstance::render(Renderer &renderer, const Tag &tag) const
{
	object.render(renderer, *this, tag);
}

void ObjectInstance::setup_render(Renderer &renderer, const Tag &) const
{
	renderer.transform(matrix);
}

unsigned ObjectInstance::get_level_of_detail(const Renderer &renderer) const
{
	return renderer.get_object_lod_bias();
}


ObjectInstance::Loader::Loader(ObjectInstance &o):
	DataFile::ObjectLoader<ObjectInstance>(o)
{
	add("transform", &Loader::transform);
}

void ObjectInstance::Loader::transform()
{
	Transform trn;
	load_sub(trn);
	obj.matrix = trn.to_matrix();
}

} // namespace GL
} // namespaec Msp
